Require Import connectives.
Require Import leibniz.
Require Import logic.
Parameter nat : Type.
Parameter S : nat -> nat.
Parameter filter_nat_type : forall (return_:Type), (nat -> return_) -> nat -> return_.
Axiom axiom_filter_nat_type_S : forall return_type, forall (return_:(nat -> return_type)), forall (n:nat), connectives.equal (return_type) (filter_nat_type (return_type) return_ (S n)) (return_ (S n)).
Definition eq_filter_nat_type_S : forall return_type, forall (return_:(nat -> return_type)), forall (n:nat), leibniz.leibniz (return_type) (filter_nat_type (return_type) return_ (S n)) (return_ (S n)) := fun (return_type:Type) => fun (return_:nat -> return_type) => fun (n:nat) => ((((connectives.equal_leibniz) (return_type)) (filter_nat_type (return_type) return_ (S n))) (return_ (S n))) ((((axiom_filter_nat_type_S) (return_type)) (return_)) (n)).
Definition sym_eq_filter_nat_type_S : forall return_type, forall (return_:(nat -> return_type)), forall (n:nat), leibniz.leibniz (return_type) (return_ (S n)) (filter_nat_type (return_type) return_ (S n)) := fun (return_type:Type) => fun (return_:nat -> return_type) => fun (n:nat) => ((((leibniz.sym_leibniz) (return_type)) (filter_nat_type (return_type) return_ (S n))) (return_ (S n))) ((((eq_filter_nat_type_S) (return_type)) (return_)) (n)).
Parameter plus : nat -> nat -> nat.
Parameter times : nat -> nat -> nat.
Parameter times_body : nat -> nat -> nat.
Axiom axiom_times : forall (n:nat), connectives.equal (nat -> nat) (times n) (filter_nat_type (nat -> nat) times_body n).
Definition eq_times : forall (n:nat), leibniz.leibniz (nat -> nat) (times n) (filter_nat_type (nat -> nat) times_body n) := fun (n:nat) => ((((connectives.equal_leibniz) (nat -> nat)) (times n)) (filter_nat_type (nat -> nat) times_body n)) ((axiom_times) (n)).
Definition sym_eq_times : forall (n:nat), leibniz.leibniz (nat -> nat) (filter_nat_type (nat -> nat) times_body n) (times n) := fun (n:nat) => ((((leibniz.sym_leibniz) (nat -> nat)) (times n)) (filter_nat_type (nat -> nat) times_body n)) ((eq_times) (n)).
Axiom axiom_times_body_S : forall (n:nat), connectives.equal (nat -> nat) (times_body (S n)) (fun (m:nat) => plus m (times n m)).
Definition eq_times_body_S : forall (n:nat), leibniz.leibniz (nat -> nat) (times_body (S n)) (fun (m:nat) => plus m (times n m)) := fun (n:nat) => ((((connectives.equal_leibniz) (nat -> nat)) (times_body (S n))) (fun (m:nat) => plus m (times n m))) ((axiom_times_body_S) (n)).
Definition sym_eq_times_body_S : forall (n:nat), leibniz.leibniz (nat -> nat) (fun (m:nat) => plus m (times n m)) (times_body (S n)) := fun (n:nat) => ((((leibniz.sym_leibniz) (nat -> nat)) (times_body (S n))) (fun (m:nat) => plus m (times n m))) ((eq_times_body_S) (n)).
Definition times_Sn_m : forall (n:nat), forall (m:nat), logic.eq (nat) (plus m (times n m)) (times (S n) m) := fun (n:nat) => fun (m:nat) => (((sym_eq_times) (S n)) (fun (y:(nat -> nat)) => logic.eq (nat) (plus m (times n m)) (y m))) ((((((sym_eq_filter_nat_type_S) (nat -> nat)) (times_body)) (n)) (fun (y:(nat -> nat)) => logic.eq (nat) (plus m (times n m)) (y m))) ((((sym_eq_times_body_S) (n)) (fun (y:(nat -> nat)) => logic.eq (nat) (plus m (times n m)) (y m))) (((logic.refl) (nat)) (plus m (times n m))))).
